# Ipopt::CGPenaltyCq Class Reference

Class for all Chen-Goldfarb penalty method specific calculated quantities. More...

`#include <IpCGPenaltyCq.hpp>`

Inheritance diagram for Ipopt::CGPenaltyCq:
[legend]

List of all members.

## Public Member Functions
bool | Initialize (const Journalist &jnlst, const OptionsList &options, const std::string &prefix)
| This method must be called to initialize the global algorithmic parameters.
Constructors/Destructors
| CGPenaltyCq (IpoptNLP *ip_nlp, IpoptData *ip_data, IpoptCalculatedQuantities *ip_cg)
| Constructor.
virtual | ~CGPenaltyCq ()
| Default destructor.
Methods for the Chen-Goldfarb line search
Number | curr_jac_cd_norm (Index nrm_type)
| Compute ||delta_c, delta_d||_infty.
Number | curr_scaled_y_Amax ()
| Compute gradient scaling based y->Amax.
Number | curr_added_y_nrm2 ()
| Compute the 2-norm of y plus delta y.
Number | curr_penalty_function ()
| Method for the penalty function at current point.
Number | trial_penalty_function ()
| Method for the penalty function at trial point.
Number | curr_direct_deriv_penalty_function ()
| Method for the directional derivative of the penalty function at current point with current step in delta.
Number | curr_fast_direct_deriv_penalty_function ()
| Method for the directional derivative of the penalty function at current point with current "fast" step in delta_cgpen.
Number | dT_times_barH_times_d ()
| Quality of d^T Aug(H) d.
Number | curr_cg_pert_fact ()
| Method for the current value for the perturbation factor for the Chen-Goldfarb method.
Number | compute_curr_cg_penalty (const Number)
| Method for choose line search penalty parameter.
Number | compute_curr_cg_penalty_scale ()
| Method for choose penalty parameters for scaling the KKT system.
## Private Member Functions
CGPenaltyData & | CGPenData ()
| Method to easily access CGPenalty data.
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| CGPenaltyCq ()
| Default Constructor.
| CGPenaltyCq (const CGPenaltyCq &)
| Copy Constructor.
void | operator= (const CGPenaltyCq &)
| Overloaded Equals Operator.
## Private Attributes
bool | initialize_called_
| flag indicating if Initialize method has been called (for debugging)
Pointers for easy access to data and NLP information. To
avoid circular references of Smart Pointers, we use a regular pointer here.
IpoptNLP * | ip_nlp_
IpoptData * | ip_data_
IpoptCalculatedQuantities * | ip_cq_
Caches for the Chen-Goldfarb line search
CachedResults< Number > | curr_fast_direct_deriv_penalty_function_cache_
CachedResults< Number > | curr_jac_cd_norm_cache_
CachedResults< Number > | curr_scaled_y_Amax_cache_
CachedResults< Number > | curr_added_y_nrm2_cache_
CachedResults< Number > | curr_penalty_function_cache_
| Cache for the penalty function at current point.
CachedResults< Number > | trial_penalty_function_cache_
| Cache for the penalty function at trial point.
CachedResults< Number > | curr_direct_deriv_penalty_function_cache_
| Cache for the directional derivative of the penalty function at current point with step in delta.
CachedResults< Number > | curr_cg_pert_fact_cache_
| Cache for Chen-Goldfarb perturbation factor.
Number | reference_infeasibility_
| Parameters for penalty method.
static void | RegisterOptions (const SmartPtr< RegisteredOptions > &roptions)
| Methods for IpoptType.

## Detailed Description

Class for all Chen-Goldfarb penalty method specific calculated quantities.

Definition at line 22 of file IpCGPenaltyCq.hpp.

## Constructor & Destructor Documentation

Ipopt::CGPenaltyCq::CGPenaltyCq | ( | IpoptNLP * | ip_nlp,
|  | IpoptData * | ip_data,
|  | IpoptCalculatedQuantities * | ip_cg |
| ) |  |  |

Constructor.

virtual Ipopt::CGPenaltyCq::~CGPenaltyCq | ( |  | ) | `[virtual]`

Default destructor.

Ipopt::CGPenaltyCq::CGPenaltyCq | ( |  | ) | `[private]`

Default Constructor.

Ipopt::CGPenaltyCq::CGPenaltyCq | ( | const CGPenaltyCq & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::CGPenaltyCq::Initialize | ( | const Journalist & | jnlst,
|  | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

This method must be called to initialize the global algorithmic parameters.

The parameters are taken from the OptionsList object.

Implements Ipopt::IpoptAdditionalCq.

Number Ipopt::CGPenaltyCq::curr_jac_cd_norm | ( | Index | nrm_type | ) |

Compute ||delta_c, delta_d||_infty.

Number Ipopt::CGPenaltyCq::curr_scaled_y_Amax | ( |  | ) |

Compute gradient scaling based y->Amax.

Number Ipopt::CGPenaltyCq::curr_added_y_nrm2 | ( |  | ) |

Compute the 2-norm of y plus delta y.

Number Ipopt::CGPenaltyCq::curr_penalty_function | ( |  | ) |

Method for the penalty function at current point.

Number Ipopt::CGPenaltyCq::trial_penalty_function | ( |  | ) |

Method for the penalty function at trial point.

Number Ipopt::CGPenaltyCq::curr_direct_deriv_penalty_function | ( |  | ) |

Method for the directional derivative of the penalty function at current point with current step in delta.

Number Ipopt::CGPenaltyCq::curr_fast_direct_deriv_penalty_function | ( |  | ) |

Method for the directional derivative of the penalty function at current point with current "fast" step in delta_cgpen.

Number Ipopt::CGPenaltyCq::dT_times_barH_times_d | ( |  | ) |

Quality of d^T Aug(H) d.

Number Ipopt::CGPenaltyCq::curr_cg_pert_fact | ( |  | ) |

Method for the current value for the perturbation factor for the Chen-Goldfarb method.

The factor is computed as 2-norm of the constraints devided by the current penbalty parameter

Number Ipopt::CGPenaltyCq::compute_curr_cg_penalty | ( | const | Number | ) |

Method for choose line search penalty parameter.

Number Ipopt::CGPenaltyCq::compute_curr_cg_penalty_scale | ( |  | ) |

Method for choose penalty parameters for scaling the KKT system.

static void Ipopt::CGPenaltyCq::RegisterOptions | ( | const SmartPtr< RegisteredOptions > & | roptions | ) | `[static]`

Methods for IpoptType.

void Ipopt::CGPenaltyCq::operator= | ( | const CGPenaltyCq & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::IpoptAdditionalCq.

CGPenaltyData& Ipopt::CGPenaltyCq::CGPenData | ( |  | ) | `[inline, private]`

Method to easily access CGPenalty data.

Definition at line 115 of file IpCGPenaltyCq.hpp.

## Member Data Documentation

IpoptNLP* Ipopt::CGPenaltyCq::ip_nlp_`[private]`

Definition at line 109 of file IpCGPenaltyCq.hpp.

IpoptData* Ipopt::CGPenaltyCq::ip_data_`[private]`

Definition at line 110 of file IpCGPenaltyCq.hpp.

IpoptCalculatedQuantities* Ipopt::CGPenaltyCq::ip_cq_`[private]`

Definition at line 111 of file IpCGPenaltyCq.hpp.

CachedResults<Number> Ipopt::CGPenaltyCq::curr_fast_direct_deriv_penalty_function_cache_`[private]`

Definition at line 125 of file IpCGPenaltyCq.hpp.

CachedResults<Number> Ipopt::CGPenaltyCq::curr_jac_cd_norm_cache_`[private]`

Definition at line 126 of file IpCGPenaltyCq.hpp.

CachedResults<Number> Ipopt::CGPenaltyCq::curr_scaled_y_Amax_cache_`[private]`

Definition at line 127 of file IpCGPenaltyCq.hpp.

CachedResults<Number> Ipopt::CGPenaltyCq::curr_added_y_nrm2_cache_`[private]`

Definition at line 128 of file IpCGPenaltyCq.hpp.

CachedResults<Number> Ipopt::CGPenaltyCq::curr_penalty_function_cache_`[private]`

Cache for the penalty function at current point.

Definition at line 130 of file IpCGPenaltyCq.hpp.

CachedResults<Number> Ipopt::CGPenaltyCq::trial_penalty_function_cache_`[private]`

Cache for the penalty function at trial point.

Definition at line 132 of file IpCGPenaltyCq.hpp.

CachedResults<Number> Ipopt::CGPenaltyCq::curr_direct_deriv_penalty_function_cache_`[private]`

Cache for the directional derivative of the penalty function at current point with step in delta.

Definition at line 135 of file IpCGPenaltyCq.hpp.

CachedResults<Number> Ipopt::CGPenaltyCq::curr_cg_pert_fact_cache_`[private]`

Cache for Chen-Goldfarb perturbation factor.

Definition at line 137 of file IpCGPenaltyCq.hpp.

Number Ipopt::CGPenaltyCq::reference_infeasibility_`[private]`

Parameters for penalty method.

Definition at line 142 of file IpCGPenaltyCq.hpp.

bool Ipopt::CGPenaltyCq::initialize_called_`[private]`

flag indicating if Initialize method has been called (for debugging)

Definition at line 147 of file IpCGPenaltyCq.hpp.

The documentation for this class was generated from the following file:

- src/contrib/CGPenalty/IpCGPenaltyCq.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines